evIPC equ 7
;-------------------------------------------------------------------------------
;inline fastcall void registerIPCbuffer(dword ECX, EDX)
;//ecx - pointer to buffer, edx - buffer size
;{
;   EAX=60;
;   EBX=1;
;   $int 0x40
;}
macro registerIPCbuffer __pointer_to_buffer, __size
{
    mov edx,__size		 ;this mustn't be in your C code
    mov ecx,__pointer_to_buffer  ;this mustn't be in your C code
    mov eax,60
    mov ebx,1
    int 0x40
}

;-------------------------------------------------------------------------------
;inline fastcall void build_commandline(dword EDI, ESI)
;//edi - pointer to the area, where the line with parameters for MeView
;//will be placed, esi - offset of full path to file
;{
;...  //see asm code
;}
macro build_commandline _pointer_to_memory_area_for_command_line, __fname
{
    local .1
    local .3
    mov esi,__fname
    mov edi,_pointer_to_memory_area_for_command_line ;this mustn't be in your C code
;<>I don't know how you'll do it but between these strokes must be the code,...
    get_PID
;<>...that doesn't affect EDI, ESI and returns the PID of current thread in EBX
    mov eax,'IPCN'
    stosd
    mov ecx,8
.1:
    rol ebx,4
    mov eax,ebx
    and al,0xF
    add al,'0'
    cmp al,'9'
    jbe @f
    add al,('A'-'0'-10)
@@:
    stosb
    loop .1
.3:	    ;copy filename
    lodsb
    stosb
    or al,al
    jnz .3
}

;-------------------------------------------------------------------------------
;inline fastcall int RunMV(int param_line) //"int param_line"? really "char* param_line", but it's simplier
;const char path[]='/sys/mv\0';
;{
;f70.func   = 7; //run application
;f70.param1 = 0;
;f70.param2 = param_line;
;f70.param3 = 0;
;f70.param4 = 0;
;f70.rezerv = 0;
;f70.name   = #path;
;EAX=70;
;EBX=#f70;
;$int 0x40
;}
macro RunMV _____parameters
{
local ___structure
    jmp @f
___structure:
    dd 7
    dd 0
    dd _____parameters
    dd 0
    dd 0
    db '/sys/mv',0
@@:
    mov eax,70
    mov ebx,___structure
    int 0x40
}

;-------------------------------------------------------------------------------
macro get_PID ;it's my variant, you can have your own
{
    mov eax,9
    mov ebx,proc_info
    or	ecx,-1
    int 0x40
    mov ebx,[proc_info+30] ;MY PID/TID
}

