;-------------------------------------------------------------------------------
;SUBROUTINES--------------------------------------------------------------------
;-------------------------------------------------------------------------------
DrawWindow:
  mcall 12,1 ;begin redraw ;, ⨯,  ॢᨫ  ।

  xor eax,eax
  mov ebx,100*65536+9
  add bx,[CurrentImage.Width]
  mov ecx,100*65536+26
  add cx,[CurrentImage.Height]
  mov edx,0x74FFFFFF
  mov esi,eax
  mov edi,main_commandline
  int 0x40
  call DrawImage
  mcall 12,2 ;end draw
  ret

DrawImage:
  mov eax,65
  mov ebx,[CurrentImage.StartOfImage]
  movzx ecx,[CurrentImage.Width]
  shl ecx,16
  add cx,[CurrentImage.Height]
  xor edx,edx
  mov esi,[BitsPerPixel]
  mov edi,[CurrentImage.Palette]
  xor ebp,ebp
  int 0x40
  ret
;쭮 ,   㦥 @%6@ ᨤ    - 
; ||-  C--   ᬥ, ࠧ뢠 ,   㦥  祢. 祭
;,   - ,      ய .
;-------------------------------------------------------------------------------
;inline fastcall void SetEventMask(dword EBX)
;//ebx - new event mask
;{
;   EAX=40;
;   $int 0x40
;}
macro SetEventMask ____mask
{
    mov ebx,____mask   ;this mustn't be in your C code
    mov eax,40
    int 0x40
}

;-------------------------------------------------------------------------------
;inline fastcall int WaitForEventTimeout(dword EBX)
;//ebx - timeout for waiting for event
;{
;   EAX=23;
;   $int 0x40
;}
macro WaitForEventTimeout ___timeout
{
    mov ebx,___timeout ;this mustn't be in your C code
    mov eax,23
    int 0x40
}

;-------------------------------------------------------------------------------
;inline fastcall int WaitForEvent()
;{
;   EAX=10;
;   $int 0x40
;}
macro WaitForEvent
{
    mov eax,10
    int 0x40
}

;-------------------------------------------------------------------------------
;fastcall int GetNthImageInfo(dword ESI, EDI, ECX)
;//esi - pointer to structure with multiple images
;//edi - pointer to CurrentImage structure
;//ecx - CurrentFrameNum
;returns 0 if error
;{
;   EAX = 0;
;   EBX = ESI;
;   $jecxz _end_loop
;_1
;   $TEST ESI,ESI
;   $JZ  __exit
;   $MOV ESI,[ESI]
;   $ADD ESI,EBX
;   $loop __1
;_end_loop:
;   $LODSD
;   $MOVSD     //left and top
;   $MOVSD     //width and height
;   $MOVSD     //delay
;   $MOVSD     //displacement
;   $LODSD
;   $TEST EAX,EAX
;   $JS _no_palette
;   $ADD EAX,EBX
;   EBX = ESI; //as far, as I remember, esi is used for indexing in structures
;   CurrentImage.Palette=EBX;
;   CurrentImage.StartOfImage=EAX;
;   BitsPerPixel=8;
;   goto __exit;
;_no_palette:
;   EBX = ESI;
;   BitsPerPixel=(-EAX);
;   CurrentImage.Palette=0;
;   CurrentImage.StartOfImage=EBX;
;__exit:
;}
GetNthImageInfo:
    mov esi,ipc_buffer+16    ;this mustn't be in your C code
    mov ecx,[CurrentFrameNum] ;this mustn't be in your C code
    mov edi,CurrentImage     ;this mustn't be in your C code

    xor  eax,eax
    mov  ebx,esi
    jecxz ____eloop
@@:
    test esi,esi
    jz	 ____exit
    mov  esi,[esi]
    add  esi,ebx
    loop @b
____eloop:
    lodsd
    movsd
    movsd
    movsd
    movsd
    lodsd
    test eax,eax
    js	 ____no_palette
    add  eax,ebx
    mov  [CurrentImage.StartOfImage],eax
    mov  [CurrentImage.Palette],esi
    mov  [BitsPerPixel],8
    jmp  ____exit
____no_palette:
    neg  eax
    mov  [BitsPerPixel],eax
    and  [CurrentImage.Palette],0
    mov  [CurrentImage.StartOfImage],esi
____exit:
    ret

